import 'package:calculator/Model/question.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

class QuizApp extends StatefulWidget {
  const QuizApp({Key key}) : super(key: key);

  @override
  _QuizAppState createState() => _QuizAppState();
}

class _QuizAppState extends State<QuizApp> {
  int _currentQuestionIndex = 0;
  List questionBank = [
    Question.name(
        "When Mickey Mouse debuted on screen in 1928, it was in a silent film.",
        true),
    Question.name(
        "Lightning is seen before it's heard because light travels faster than sound.",
        true),
    Question.name(
        "Kakapo bird has a strong, pleasant, musty odor which allows predators to easily locate it. Hence, it is critically endangered",
        true),
    Question.name(
        "A mantis shrimp can swing its claw so fast it boils the water around it and creates a flash of light.",
        true),
    Question.name(
        "Most of the birds cannot swallow their food without gravity", true),
    Question.name("Penguins propose to each other with singing.", false),
    Question.name(
        "The male giraffe tastes her saliva and that helps it determine whether the female is ovulating.",
        false),
    Question.name(
        "There are more possible iterations of a game of chess than there are atoms in the known universe.",
        true),
    Question.name(
        "An octopus has three hearts, nine brains, and blue blood.", true),
    Question.name(
        "A cat's meow is a form of communication with humans only, not other cats.",
        true),
    Question.name(
        "Squirrels plant thousands of trees every year, worldwide, due to simply forgetting where they buried their acorns.",
        true)
  ];

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text("Fast Quiz"),
        centerTitle: true,
        backgroundColor: Colors.blue,
      ),
      backgroundColor: Colors.white,
      // We use Builder here to use a context that os a descendent of Scaffold
      // or else Scaffold will remain null
      body: Builder(
        builder: (BuildContext context) => Container(
            child: Column(
          mainAxisAlignment: MainAxisAlignment.center,
          children: <Widget>[
            Center(
              child: Padding(
                padding: const EdgeInsets.all(15.0),
                child: Image.asset(
                  "images/quiz.png",
                  width: 250,
                  height: 180,
                ),
              ),
            ),
            Padding(
              padding: const EdgeInsets.all(12.0),
              child: Container(
                decoration: BoxDecoration(
                    color: Colors.transparent,
                    borderRadius: BorderRadius.circular(14.4),
                    border: Border.all(
                        color: Colors.blue.shade700, style: BorderStyle.solid)),
                height: 120.0,
                child: Center(
                    child: Padding(
                  padding: const EdgeInsets.all(8.0),
                  child: Text(
                    questionBank[_currentQuestionIndex].questiontext,
                    style: TextStyle(fontSize: 16.9, color: Colors.black),
                  ),
                )),
              ),
            ),
            Row(
              mainAxisAlignment: MainAxisAlignment.spaceEvenly,
              children: <Widget>[
                RaisedButton(onPressed: () => previousQuestion(),
                  color: Colors.purpleAccent.shade400,
                  child: Icon(Icons.arrow_back, color: Colors.white),
                ),

                RaisedButton(onPressed: () => _checkAnswer(true, context),
                color: Colors.greenAccent.shade700,
                  child: Text("TRUE", style: TextStyle(color: Colors.white)),
                ),

                RaisedButton(onPressed: () => _checkAnswer(false, context),
                  color: Colors.redAccent.shade700,
                  child: Text("FALSE", style: TextStyle(color: Colors.white)),
                ),

                RaisedButton(onPressed: () => nextQuestion(),
                  color: Colors.purpleAccent.shade400,
                  child: Icon(Icons.arrow_forward, color: Colors.white),
                ),



              ],

            ),
            Spacer()
          ],
        )),
      ),
    );

  }

  void _checkAnswer(bool userChoice, BuildContext context) {
    if(userChoice == questionBank[_currentQuestionIndex].isCorrect) {
      // correct answer
      final snackBar = SnackBar(
        backgroundColor: Colors.greenAccent.shade700,
          //duration: Duration(microseconds: 6000),
          content: Text('Correct!'));
      ScaffoldMessenger.of(context).showSnackBar(snackBar);

      //debugPrint("Yes Correct!");
      updateQuestion();
    } else {
      final snackBar = SnackBar(
        backgroundColor: Colors.redAccent.shade700,
          //duration: Duration(microseconds: 500),
          content: Text('Incorrect!'));
      ScaffoldMessenger.of(context).showSnackBar(snackBar);
      //debugPrint("Incorrect!");
      updateQuestion();
    }

  }

  updateQuestion() {
    setState(() {
      _currentQuestionIndex = (_currentQuestionIndex +1) % questionBank.length;
    });
  }

  nextQuestion() {
    updateQuestion();


  }

  previousQuestion() {
    setState(() {
      _currentQuestionIndex = (_currentQuestionIndex -1) % questionBank.length;
    });
  }
}





 